// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_CODE_DIALOG_H
#define _HILDONMM_CODE_DIALOG_H


#include <glibmm.h>

/* $Id: code-dialog.hg,v 1.10 2006/22/9 10:52:44 murrayc Exp $ */

/* code-dialog.h
 *
 * Copyright 2005-2007 The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonCodeDialog HildonCodeDialog;
typedef struct _HildonCodeDialogClass HildonCodeDialogClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class CodeDialog_Class; } // namespace Hildon
namespace Hildon
{

//TODO: Class documentation. There is none in the .c file (no SECTION: comment). murrayc

/** A keypad-like widget used to enter pincodes.
 * This dialog displays a keypad that can be used to enter 
 * numerical pin codes or lock codes. It emits an 'input' signal each time 
 * an input action is performed on the dialog.
 *
 * @ingroup HildonDialogs
 */

class CodeDialog : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef CodeDialog CppObjectType;
  typedef CodeDialog_Class CppClassType;
  typedef HildonCodeDialog BaseObjectType;
  typedef HildonCodeDialogClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~CodeDialog();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class CodeDialog_Class;
  static CppClassType codedialog_class_;

  // noncopyable
  CodeDialog(const CodeDialog&);
  CodeDialog& operator=(const CodeDialog&);

protected:
  explicit CodeDialog(const Glib::ConstructParams& construct_params);
  explicit CodeDialog(HildonCodeDialog* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonCodeDialog*       gobj()       { return reinterpret_cast<HildonCodeDialog*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonCodeDialog* gobj() const { return reinterpret_cast<HildonCodeDialog*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_input();
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:
  CodeDialog();

  
  /** Use this function to access the code entered by the user.
   * @return The entered code.
   */
  Glib::ustring get_code() const;
  
  void clear_code();
		
  
  /** Use this function to set the text that will be displayd in the
   * help label
   * @param text The text to use in the help label.
   */
  void set_help_text(const Glib::ustring& text);
  
  /** This function will block or enable the input on the code dialog by
   * making the input button sensitive (or not).
   * @param sensitive The new state.
   */
  void set_input_sensitive(bool sensitive = true);

  
   /**
   * @par Prototype:
   * <tt>void %input()</tt>
   */

  Glib::SignalProxy0< void > signal_input();
 

};

} //namespace Hildon


namespace Glib
{
  /** @relates Hildon::CodeDialog
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::CodeDialog* wrap(HildonCodeDialog* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_CODE_DIALOG_H */

