// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_SET_PASSWORD_DIALOG_H
#define _HILDONMM_SET_PASSWORD_DIALOG_H


#include <glibmm.h>

/* $Id: set-password-dialog.hg,v 1.10 2005/02/15 10:52:44 murrayc Exp $ */

/* set-password-dialog.h
 *
 * Copyright 2005-2007 The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonSetPasswordDialog HildonSetPasswordDialog;
typedef struct _HildonSetPasswordDialogClass HildonSetPasswordDialogClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class SetPasswordDialog_Class; } // namespace Hildon
namespace Hildon
{

/** Hildon::SetPasswordDialog allows the setting and changing of a password. 
 * 
 * In Change mode, the dialog is used to change or remove an existing
 * password. Unselecting the check box dims the password fields below
 * it. If the dialog is accepted with 'OK' while the check box is
 * unselected, a confirmation note is shown.  If the confirmation note
 * dialog is accepted with 'Remove', the password protection is removed.  
 * 
 * In Set mode, the dialog is used to define a password, or
 * change a password that cannot be removed.
 *
 * @ingroup HildonDialogs
 */

class SetPasswordDialog : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef SetPasswordDialog CppObjectType;
  typedef SetPasswordDialog_Class CppClassType;
  typedef HildonSetPasswordDialog BaseObjectType;
  typedef HildonSetPasswordDialogClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~SetPasswordDialog();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class SetPasswordDialog_Class;
  static CppClassType setpassworddialog_class_;

  // noncopyable
  SetPasswordDialog(const SetPasswordDialog&);
  SetPasswordDialog& operator=(const SetPasswordDialog&);

protected:
  explicit SetPasswordDialog(const Glib::ConstructParams& construct_params);
  explicit SetPasswordDialog(HildonSetPasswordDialog* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonSetPasswordDialog*       gobj()       { return reinterpret_cast<HildonSetPasswordDialog*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonSetPasswordDialog* gobj() const { return reinterpret_cast<HildonSetPasswordDialog*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:

  /** Constructs a new Hildon::SetPasswordDialog.
   *
   * @param modify_protection If this is true, a new change password dialog will be created. If false, then a new set password dialog will be created. 
   */
  explicit SetPasswordDialog(bool modify_protection);

  /** Constructs a new Hildon::SetPasswordDialog.
   *
   * @param parent Parent window.
   * @param modify_protection If this is true, a new change password dialog will be created. If false, then a new set password dialog will be created. 
   */
  SetPasswordDialog(Gtk::Window& parent, bool modify_protection);
  

  /** Constructs a new Hildon::SetPasswordDialog.
   *
   * @param password The default password for the password field.
   * @param modify_protection If this is true, a new change password dialog will be created. If false, then a new set password dialog will be created. 
   */
  SetPasswordDialog(const Glib::ustring& password, bool modify_protection);

  /** Constructs a new Hildon::SetPasswordDialog with a default password in the password field.
   *
   * @param parent Parent window.
   * @param password The default password for the password field.
   * @param modify_protection If this is true, a new change password dialog will be created. If false, then a new set password dialog will be created. 
   */
  SetPasswordDialog(Gtk::Window& parent, const Glib::ustring& password, bool modify_protection);
  

  /** Returns: changed password ( if the dialog is successfully
   * @return Changed password ( if the dialog is successfully 
   * accepted with 'OK' ( and when the check box is 'ON' ( in Change Password
   * Dialog )).
   */
  Glib::ustring get_password() const;
  
  /** Returns: password protection mode ( <tt>true</tt> when the protection is
   * @return Password protection mode ( <tt>true</tt> when the protection is
   * 'ON' and <tt>false</tt> when the protection is 'OFF' ).
   */
  bool get_protected() const;

  
  /** Sets the optional descriptive text.
   * @param message The message or some other descriptive text to be set.
   */
  void set_message(const Glib::ustring& message);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** A message to display to the user.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_message() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** A message to display to the user.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_message() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Set type to dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_modify_protection() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Set content to dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_password() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Set content to dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_password() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::SetPasswordDialog
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::SetPasswordDialog* wrap(HildonSetPasswordDialog* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_SET_PASSWORD_DIALOG_H */

