// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_WIZARD_DIALOG_H
#define _HILDONMM_WIZARD_DIALOG_H


#include <glibmm.h>

/* $Id: time-picker.hg,v 1.10 2005/02/15 10:52:44 murrayc Exp $ */

/* sort-dialog.h
 *
 * Copyright 2005-2007 The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>
#include <gtkmm/notebook.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonWizardDialog HildonWizardDialog;
typedef struct _HildonWizardDialogClass HildonWizardDialogClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class WizardDialog_Class; } // namespace Hildon
namespace Hildon
{

//TODO: When bug #884 has been fixed: _WRAP_ENUM(WizardDialogResponse, HildonWizardDialogResponse)

/** The Hildon::WizardDialog widget provides a guided configuration
 * process. The dialog has four standard buttons, previous, next,
 * finish, cancel, and contains several pages with optional icons.
 * Response buttons are dimmed/undimmed automatically and the standard
 * icon is shown/hidden in response to page navigation. The notebook
 * widget provided by users contains the actual wizard pages.
 *
 * See the WizardDialogResponse enum for the possible responses, for instance from Gtk::Dialog::run().
 *
 * @ingroup HildonDialogs
 */

class WizardDialog : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef WizardDialog CppObjectType;
  typedef WizardDialog_Class CppClassType;
  typedef HildonWizardDialog BaseObjectType;
  typedef HildonWizardDialogClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~WizardDialog();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class WizardDialog_Class;
  static CppClassType wizarddialog_class_;

  // noncopyable
  WizardDialog(const WizardDialog&);
  WizardDialog& operator=(const WizardDialog&);

protected:
  explicit WizardDialog(const Glib::ConstructParams& construct_params);
  explicit WizardDialog(HildonWizardDialog* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonWizardDialog*       gobj()       { return reinterpret_cast<HildonWizardDialog*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonWizardDialog* gobj() const { return reinterpret_cast<HildonWizardDialog*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:

  /** Creates a new Hildon::WizardDialog.
   *
   * @param wizard_name The name of dialog.
   * @param wizard_notebook The notebook to be shown on the dialog.
   */
  WizardDialog(const Glib::ustring& wizard_name, Gtk::Notebook& wizard_notebook);

 /** Creates a new Hildon::WizardDialog.
   *
   * Remember to call set_wizard_notebook().
   *
   * @param wizard_name The name of dialog.
   */
  WizardDialog(const Glib::ustring& wizard_name);

  /** Creates a new Hildon::WizardDialog.
   *
   * @param parent a Gtk::Window.
   * @param wizard_name The name of dialog.
   * @param wizard_notebook The notebook to be shown on the dialog.
   */
  WizardDialog(Gtk::Window& parent, const Glib::ustring& wizard_name, Gtk::Notebook& wizard_notebook);
  

  /** Sets the notebook used by the wizard dialog.
   * Each page in the notebook will be a page in the wizard dialog.
   */
  void set_wizard_notebook(Gtk::Notebook& notebook);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The name of the HildonWizardDialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_wizard_name() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** The name of the HildonWizardDialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_wizard_name() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** GtkNotebook object to be used in the HildonWizardDialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::Notebook*> property_wizard_notebook() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** GtkNotebook object to be used in the HildonWizardDialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::Notebook*> property_wizard_notebook() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** If the wizard should autotitle itself.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_autotitle() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** If the wizard should autotitle itself.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_autotitle() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::WizardDialog
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::WizardDialog* wrap(HildonWizardDialog* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_WIZARD_DIALOG_H */

